## libcifpp 7.0.7

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.23)

# set the project name
project(
	libcifpp
	VERSION 7.0.7
	LANGUAGES CXX)

list(PREPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(FindAtomic)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(CheckCXXSourceCompiles)
include(GenerateExportHeader)
include(CTest)
include(FetchContent)

# When building with ninja-multiconfig, build both debug and release by default
if(CMAKE_GENERATOR STREQUAL "Ninja Multi-Config")
	set(CMAKE_CROSS_CONFIGS "Debug;Release")
	set(CMAKE_DEFAULT_CONFIGS "Debug;Release")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers"
	)
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Build documentation?
option(BUILD_DOCUMENTATION "Build the documentation" OFF)

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4")

# Building shared libraries?
if(NOT(BUILD_FOR_CCP4 AND WIN32))
	option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)
endif()

if(PROJECT_IS_TOP_LEVEL AND NOT BUILD_FOR_CCP4)
	# Lots of code depend on the availability of the components.cif file
	option(CIFPP_DOWNLOAD_CCD
		"Download the CCD file components.cif during installation" ON)

	# An optional cron script can be installed to keep the data files up-to-date
	if(UNIX AND NOT APPLE)
		option(CIFPP_INSTALL_UPDATE_SCRIPT
			"Install the script to update CCD and dictionary files" ON)
	endif()
else()
	unset(CIFPP_DOWNLOAD_CCD)
	unset(CIFPP_INSTALL_UPDATE_SCRIPT)
endif()

# When CCP4 is sourced in the environment, we can recreate the symmetry
# operations table
if(EXISTS "$ENV{CCP4}/lib/data/syminfo.lib")
	option(CIFPP_RECREATE_SYMOP_DATA
		"Recreate SymOp data table in case it is out of date" ON)
endif()

# CCP4 build
if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(PREPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(PREPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif()
endif()

# Now include the GNUInstallDirs module
include(GNUInstallDirs)

if(WIN32)
	if(${CMAKE_SYSTEM_VERSION} GREATER_EQUAL 10) # Windows 10
		add_definitions(-D _WIN32_WINNT=0x0A00)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.3) # Windows 8.1
		add_definitions(-D _WIN32_WINNT=0x0603)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.2) # Windows 8
		add_definitions(-D _WIN32_WINNT=0x0602)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.1) # Windows 7
		add_definitions(-D _WIN32_WINNT=0x0601)
	elseif(${CMAKE_SYSTEM_VERSION} EQUAL 6.0) # Windows Vista
		add_definitions(-D _WIN32_WINNT=0x0600)
	else() # Windows XP (5.1)
		add_definitions(-D _WIN32_WINNT=0x0501)
	endif()

	# Man, this is 2024 we're living in...
	add_definitions(-DNOMINMAX)

	# We do not want to write an export file for all our symbols...
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive- /bigobj)
	add_link_options(/NODEFAULTLIB:library)

	# This is dubious...
	if(BUILD_SHARED_LIBS)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	else()
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	endif()
endif()

# Libraries

# Start by finding out if std:regex is usable. Note that the current
# implementation in GCC is not acceptable, it crashes on long lines. The
# implementation in libc++ (clang) and MSVC seem to be OK.
check_cxx_source_compiles(
	"
#include <iostream>
#ifndef __GLIBCXX__
#error
#endif
int main(int argc, char *argv[]) { return 0; }"
	GXX_LIBSTDCPP)

if(GXX_LIBSTDCPP)
	message(
		STATUS "Testing for known regex bug, since you're using GNU libstdc++")

	try_run(STD_REGEX_RUNNING STD_REGEX_COMPILING
		${CMAKE_CURRENT_BINARY_DIR}/test
		${CMAKE_CURRENT_SOURCE_DIR}/cmake/test-rx.cpp)

	if(STD_REGEX_RUNNING STREQUAL FAILED_TO_RUN)
		message(
			STATUS
			"You are probably trying to compile using the g++ standard library which contains a crashing std::regex implementation. Will use boost::regex instead"
		)

		find_package(Boost 1.80 QUIET COMPONENTS regex)

		if(NOT Boost_FOUND)
			set(BOOST_REGEX_STANDALONE ON)

			FetchContent_Declare(
				boost-rx
				GIT_REPOSITORY https://github.com/boostorg/regex
				GIT_TAG boost-1.83.0)

			FetchContent_MakeAvailable(boost-rx)
		endif()

		set(BOOST_REGEX ON)
	endif()
endif()

if(MSVC)
	# Avoid linking the shared library of zlib Search ZLIB_ROOT first if it is
	# set.
	if(ZLIB_ROOT)
		set(_ZLIB_SEARCH_ROOT PATHS ${ZLIB_ROOT} NO_DEFAULT_PATH)
		list(APPEND _ZLIB_SEARCHES _ZLIB_SEARCH_ROOT)
	endif()

	# Normal search.
	set(_ZLIB_x86 "(x86)")
	set(_ZLIB_SEARCH_NORMAL
		PATHS "[HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32\\Zlib;InstallPath]"
		"$ENV{ProgramFiles}/zlib" "$ENV{ProgramFiles${_ZLIB_x86}}/zlib")
	unset(_ZLIB_x86)
	list(APPEND _ZLIB_SEARCHES _ZLIB_SEARCH_NORMAL)

	if(BUILD_FOR_CCP4)
		list(PREPEND _ZLIB_SEARCHES "$ENV{CCP4}/lib")
	endif()

	foreach(search ${_ZLIB_SEARCHES})
		find_library(
			ZLIB_LIBRARY
			NAMES zlibstatic NAMES_PER_DIR ${${search}}
			PATH_SUFFIXES lib)
	endforeach()
endif()

find_package(ZLIB QUIET)
find_package(Threads)

if(NOT ZLIB_FOUND)
	message(FATAL_ERROR "The zlib development files were not found you this system, please install them and try again (hint: on debian/ubuntu use apt-get install zlib1g-dev)")
endif()

# Using Eigen3 is a bit of a thing. We don't want to build it completely since
# we only need a couple of header files. Nothing special. But often, eigen3 is
# already installed and then we prefer that.
find_package(Eigen3 3.4 QUIET)

if(Eigen3_FOUND AND TARGET Eigen3::Eigen)
	get_target_property(EIGEN_INCLUDE_DIR Eigen3::Eigen
		INTERFACE_INCLUDE_DIRECTORIES)
else()
	# Create a private copy of eigen3 and populate it only, no need to build
	FetchContent_Declare(
		my-eigen3
		GIT_REPOSITORY https://gitlab.com/libeigen/eigen.git
		GIT_TAG 3.4.0)

	FetchContent_GetProperties(my-eigen3)

	if(NOT my-eigen3_POPULATED)
		FetchContent_Populate(my-eigen3)
	endif()

	set(EIGEN_INCLUDE_DIR ${my-eigen3_SOURCE_DIR})
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header(${CMAKE_CURRENT_SOURCE_DIR}/src/ LIB_NAME "LibCIFPP")

# SymOp data table
if(CIFPP_RECREATE_SYMOP_DATA)
	# The tool to create the table
	add_executable(symop-map-generator
		"${CMAKE_CURRENT_SOURCE_DIR}/src/symop-map-generator.cpp")

	target_compile_features(symop-map-generator PUBLIC cxx_std_20)

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/src/symop_table_data.hpp
		COMMAND
		$<TARGET_FILE:symop-map-generator> $ENV{CLIBD}/syminfo.lib
		$ENV{CLIBD}/symop.lib ${CMAKE_CURRENT_SOURCE_DIR}/src/symop_table_data.hpp)

	add_custom_target(
		OUTPUT
		${CMAKE_CURRENT_SOURCE_DIR}/src/symop_table_data.hpp
		DEPENDS symop-map-generator "$ENV{CLIBD}/syminfo.lib"
		"$ENV{CLIBD}/symop.lib")
endif()

# Sources
set(project_sources
	${CMAKE_CURRENT_SOURCE_DIR}/src/category.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/condition.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/datablock.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/dictionary_parser.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/file.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/item.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/parser.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/row.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/validate.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/text.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/utilities.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/atom_type.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/compound.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/point.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/symmetry.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/model.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/cif2pdb.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/pdb2cif.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/pdb_record.hpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/pdb2cif_remark_3.hpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/pdb2cif_remark_3.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/reconstruct.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pdb/validate-pdbx.cpp
)

set(project_headers
	include/cif++.hpp
	include/cif++/atom_type.hpp
	include/cif++/category.hpp
	include/cif++/compound.hpp
	include/cif++/condition.hpp
	include/cif++/datablock.hpp
	include/cif++/dictionary_parser.hpp
	include/cif++/exports.hpp
	include/cif++/file.hpp
	include/cif++/format.hpp
	include/cif++/forward_decl.hpp
	include/cif++/gzio.hpp
	include/cif++/item.hpp
	include/cif++/iterator.hpp
	include/cif++/matrix.hpp
	include/cif++/model.hpp
	include/cif++/parser.hpp
	include/cif++/pdb/cif2pdb.hpp
	include/cif++/pdb.hpp
	include/cif++/pdb/io.hpp
	include/cif++/pdb/pdb2cif.hpp
	include/cif++/pdb/tls.hpp
	include/cif++/point.hpp
	include/cif++/row.hpp
	include/cif++/symmetry.hpp
	include/cif++/text.hpp
	include/cif++/utilities.hpp
	include/cif++/validate.hpp
)

add_library(cifpp)
add_library(cifpp::cifpp ALIAS cifpp)

target_sources(cifpp
	PRIVATE ${project_sources}
	${CMAKE_CURRENT_SOURCE_DIR}/src/symop_table_data.hpp
	PUBLIC
	FILE_SET cifpp_headers TYPE HEADERS
	BASE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include
	FILES ${project_headers}
)

# The code now really requires C++20
target_compile_features(cifpp PUBLIC cxx_std_20)

set(CMAKE_DEBUG_POSTFIX d)
set_target_properties(cifpp PROPERTIES DEBUG_POSTFIX "d")

generate_export_header(cifpp EXPORT_FILE_NAME
	${CMAKE_CURRENT_SOURCE_DIR}/include/cif++/exports.hpp)

if(BOOST_REGEX)
	target_compile_definitions(cifpp PRIVATE USE_BOOST_REGEX=1
		BOOST_REGEX_STANDALONE=1)
	get_target_property(BOOST_REGEX_INCLUDE_DIR Boost::regex
		INTERFACE_INCLUDE_DIRECTORIES)
endif()

if(MSVC)
	target_compile_definitions(cifpp PUBLIC NOMINMAX=1)
endif()

set_target_properties(cifpp PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_include_directories(
	cifpp
	PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
	PRIVATE "${BOOST_REGEX_INCLUDE_DIR}" "${EIGEN_INCLUDE_DIR}")

target_link_libraries(cifpp PUBLIC Threads::Threads ZLIB::ZLIB $<$<TARGET_EXISTS:std::atomic>:std::atomic>)

if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	target_link_options(cifpp PRIVATE -undefined dynamic_lookup)
endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")

if(CIFPP_DOWNLOAD_CCD)
	# download the components.cif file from CCD

=== debian/changelog ===
libcifpp (7.0.7-3) unstable; urgency=medium

  * Closes: #1085237

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 08:00:15 +0100

libcifpp (7.0.7-2) unstable; urgency=medium

  * Upload to unstable

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 07:59:53 +0100

libcifpp (7.0.7-1) unstable; urgency=medium

  * New upstream version 
  * Standards-Version: 4.6.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Refer to common license file for CC0-1.0.
  * Correct URLs for downloading data. Closes: #1063191
  * Added Swedish translation. Closes: #1068860

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Oct 2024 08:51:23 +0200

## libcifpp 7.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 # set the project name
 project(
 	libcifpp
-	VERSION 7.0.7
+	VERSION 7.0.9
 	LANGUAGES CXX)
 
 list(PREPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -41,6 +41,11 @@
 include(GenerateExportHeader)
 include(CTest)
 include(FetchContent)
+
+# FindBoost, take care of it now.
+if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
+	cmake_policy(SET CMP0167 NEW)
+endif()
 
 # When building with ninja-multiconfig, build both debug and release by default
 if(CMAKE_GENERATOR STREQUAL "Ninja Multi-Config")
@@ -375,5 +380,3 @@
 	target_link_options(cifpp PRIVATE -undefined dynamic_lookup)
 endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 
-if(CIFPP_DOWNLOAD_CCD)
-	# download the components.cif file from CCD

=== docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile --output-file=requirements.txt requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
beautifulsoup4==4.12.2
    # via exhale
breathe==4.35.0
    # via
    #   -r requirements.in
    #   exhale
certifi==2023.7.22
    # via requests
charset-normalizer==3.2.0
    # via requests
docutils==0.17.1
    # via
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx
    #   sphinx-rtd-theme
exhale==0.3.6
    # via -r requirements.in
idna==3.4
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.2
    # via
    #   myst-parser
    #   sphinx
lxml==4.9.3
    # via exhale
markdown-it-py==2.2.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.3
    # via jinja2
mdit-py-plugins==0.3.5
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==0.18.1
    # via -r requirements.in
packaging==23.1
    # via sphinx
pygments==2.16.1
    # via sphinx
pyyaml==6.0.1
    # via myst-parser
requests==2.31.0
    # via sphinx
six==1.16.0
    # via exhale
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.4.1
    # via beautifulsoup4
sphinx==4.5.0
    # via
    #   -r requirements.in
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx-rtd-theme
    #   sphinxcontrib-jquery
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
typing-extensions==4.7.1
    # via myst-parser
urllib3==2.0.4
    # via requests

=== test/CMakeLists.txt ===
# We're using the older version 2 of Catch2

if(NOT(Catch2_FOUND OR TARGET Catch2))
	find_package(Catch2 QUIET)

	if(NOT Catch2_FOUND)
		include(FetchContent)

		FetchContent_Declare(
			Catch2
			GIT_REPOSITORY https://github.com/catchorg/Catch2.git
			GIT_TAG v2.13.9)

		FetchContent_MakeAvailable(Catch2)

		set(Catch2_VERSION "2.13.9")
	endif()
endif()

list(
	APPEND
	CIFPP_tests
	unit-v2
	unit-3d
	format
	model
	rename-compound
	sugar
	spinner
	# reconstruction
	validate-pdbx)

add_library(test-main OBJECT "${CMAKE_CURRENT_SOURCE_DIR}/test-main.cpp")

target_link_libraries(test-main cifpp::cifpp Catch2::Catch2)

if("${Catch2_VERSION}" VERSION_LESS 3.0.0)
	target_compile_definitions(test-main PUBLIC CATCH22=1)
else()
	target_compile_definitions(test-main PUBLIC CATCH22=0)
endif()

foreach(CIFPP_TEST IN LISTS CIFPP_tests)
	set(CIFPP_TEST "${CIFPP_TEST}-test")
	set(CIFPP_TEST_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${CIFPP_TEST}.cpp")

	add_executable(
		${CIFPP_TEST} ${CIFPP_TEST_SOURCE} $<TARGET_OBJECTS:test-main>)

	if(${Catch2_VERSION} VERSION_GREATER_EQUAL 3.0.0)
		target_compile_definitions(${CIFPP_TEST} PUBLIC CATCH22=0)
	else()
		target_compile_definitions(${CIFPP_TEST} PUBLIC CATCH22=1)
	endif()

	target_link_libraries(${CIFPP_TEST} PRIVATE cifpp::cifpp Catch2::Catch2)
	target_include_directories(${CIFPP_TEST} PRIVATE "${EIGEN_INCLUDE_DIR}")

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(${CIFPP_TEST} PRIVATE /EHsc)
	endif()

	add_custom_target(
		"run-${CIFPP_TEST}"
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${CIFPP_TEST}.touch ${CIFPP_TEST})

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${CIFPP_TEST}.touch
		COMMAND $<TARGET_FILE:${CIFPP_TEST}> --data-dir
		${CMAKE_CURRENT_SOURCE_DIR})

	add_test(NAME ${CIFPP_TEST} COMMAND $<TARGET_FILE:${CIFPP_TEST}> --data-dir
		${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

=== debian/changelog ===
libcifpp (7.0.9-1) unstable; urgency=medium

  * Revert "New upstream version 7.0.7"
  * New upstream version 7.0.9

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:07:49 +0100

=== debian/control ===
Source: libcifpp
Priority: optional
Section: libs
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Maarten L. Hekkelman <maarten@hekkelman.com>,
 Andreas Tille <tille@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libboost-dev,
 libboost-regex-dev,
 libeigen3-dev,
 zlib1g-dev,
 po-debconf,
 catch2,
 cmake,
 doxygen,
 python3-exhale,
 python3-sphinx-rtd-theme,
 python3-myst-parser
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
Homepage: https://github.com/PDB-REDO/libcifpp
Rules-Requires-Root: no

Package: libcifpp-dev
Section: libdevel
Architecture: any
Depends:
 libcifpp7 (= ${binary:Version}),
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
Suggests: libcifpp-doc, mrc
Multi-Arch: same
Description: Documentation for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This specific package contains all files needed to develop new
 software using libcifpp.

Package: libcifpp-doc
Section: doc
Architecture: all
Depends:
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
Description: Development files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This specific package contains the documentation you can use to develop new
 software using libcifpp.

Package: libcifpp7
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp-data
Multi-Arch: same
Description: Library files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This package contains the library file only.

Package: libcifpp-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Breaks:
 libcifpp5.2 (<< 5.0.0-1)
Replaces:
 libcifpp5.2 (<< 5.0.0-1)
Description: Data files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This package contains the architecture independent data for the library.

## libcifpp 9.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,28 +24,25 @@
 
 cmake_minimum_required(VERSION 3.23)
 
+if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+	set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
+	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
+endif()
+
 # set the project name
 project(
 	libcifpp
-	VERSION 7.0.9
-	LANGUAGES CXX)
+	VERSION 9.0.1
+	LANGUAGES CXX C)
 
 list(PREPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 include(FindAtomic)
-include(CheckFunctionExists)
-include(CheckIncludeFiles)
-include(CheckLibraryExists)
 include(CMakePackageConfigHelpers)
-include(CheckCXXSourceCompiles)
 include(GenerateExportHeader)
 include(CTest)
+include(ExternalProject)
 include(FetchContent)
-
-# FindBoost, take care of it now.
-if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
-	cmake_policy(SET CMP0167 NEW)
-endif()
 
 # When building with ninja-multiconfig, build both debug and release by default
 if(CMAKE_GENERATOR STREQUAL "Ninja Multi-Config")
@@ -62,25 +59,23 @@
 endif()
 
 # Build documentation?
-option(BUILD_DOCUMENTATION "Build the documentation" OFF)
+set(BUILD_DOCUMENTATION OFF CACHE BOOL "Build the documentation")
 
 # Optionally build a version to be installed inside CCP4
-option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4")
+set(BUILD_FOR_CCP4 OFF CACHE BOOL "Build a version to be installed in CCP4")
 
 # Building shared libraries?
 if(NOT(BUILD_FOR_CCP4 AND WIN32))
-	option(BUILD_SHARED_LIBS "Build a shared library instead of a static one" OFF)
+	set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build a shared library instead of a static one")
 endif()
 
 if(PROJECT_IS_TOP_LEVEL AND NOT BUILD_FOR_CCP4)
 	# Lots of code depend on the availability of the components.cif file
-	option(CIFPP_DOWNLOAD_CCD
-		"Download the CCD file components.cif during installation" ON)
+	set(CIFPP_DOWNLOAD_CCD ON CACHE BOOL "Download the CCD file components.cif during installation")
 
 	# An optional cron script can be installed to keep the data files up-to-date
 	if(UNIX AND NOT APPLE)
-		option(CIFPP_INSTALL_UPDATE_SCRIPT
-			"Install the script to update CCD and dictionary files" ON)
+		set(CIFPP_INSTALL_UPDATE_SCRIPT ON CACHE BOOL "Install the script to update CCD and dictionary files")
 	endif()
 else()
 	unset(CIFPP_DOWNLOAD_CCD)
@@ -90,14 +85,13 @@
 # When CCP4 is sourced in the environment, we can recreate the symmetry
 # operations table
 if(EXISTS "$ENV{CCP4}/lib/data/syminfo.lib")
-	option(CIFPP_RECREATE_SYMOP_DATA
-		"Recreate SymOp data table in case it is out of date" ON)
+	set(CIFPP_RECREATE_SYMOP_DATA ON CACHE BOOL "Recreate SymOp data table in case it is out of date")
 endif()
 
 # CCP4 build
 if(BUILD_FOR_CCP4)
 	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
-		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
+		message(FATAL_ERROR "cifpp: A CCP4 built was requested but CCP4 was not sourced")
 	else()
 		list(PREPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
 		list(PREPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
@@ -127,9 +121,6 @@
 		add_definitions(-D _WIN32_WINNT=0x0501)
 	endif()
 
-	# Man, this is 2024 we're living in...
-	add_definitions(-DNOMINMAX)
-
 	# We do not want to write an export file for all our symbols...
 	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
 endif()
@@ -149,51 +140,8 @@
 
 # Libraries
 
-# Start by finding out if std:regex is usable. Note that the current
-# implementation in GCC is not acceptable, it crashes on long lines. The
-# implementation in libc++ (clang) and MSVC seem to be OK.
-check_cxx_source_compiles(
-	"
-#include <iostream>
-#ifndef __GLIBCXX__
-#error
-#endif
-int main(int argc, char *argv[]) { return 0; }"
-	GXX_LIBSTDCPP)
-
-if(GXX_LIBSTDCPP)
-	message(
-		STATUS "Testing for known regex bug, since you're using GNU libstdc++")
-
-	try_run(STD_REGEX_RUNNING STD_REGEX_COMPILING
-		${CMAKE_CURRENT_BINARY_DIR}/test
-		${CMAKE_CURRENT_SOURCE_DIR}/cmake/test-rx.cpp)
-
-	if(STD_REGEX_RUNNING STREQUAL FAILED_TO_RUN)
-		message(
-			STATUS
-			"You are probably trying to compile using the g++ standard library which contains a crashing std::regex implementation. Will use boost::regex instead"
-		)
-
-		find_package(Boost 1.80 QUIET COMPONENTS regex)
-
-		if(NOT Boost_FOUND)
-			set(BOOST_REGEX_STANDALONE ON)
-
-			FetchContent_Declare(
-				boost-rx
-				GIT_REPOSITORY https://github.com/boostorg/regex
-				GIT_TAG boost-1.83.0)
-
-			FetchContent_MakeAvailable(boost-rx)
-		endif()
-
-		set(BOOST_REGEX ON)
-	endif()
-endif()
-
 if(MSVC)
-	# Avoid linking the shared library of zlib Search ZLIB_ROOT first if it is
+	# Avoid linking the shared library of zlib. Search ZLIB_ROOT first if it is
 	# set.
 	if(ZLIB_ROOT)
 		set(_ZLIB_SEARCH_ROOT PATHS ${ZLIB_ROOT} NO_DEFAULT_PATH)
@@ -220,11 +168,35 @@
 	endforeach()
 endif()
 
+# First check if <format> is available
+find_file(FMT NAME format)
+
+if(FMT EQUAL "FMT-NOTFOUND")
+	if(NOT (fmt_FOUND OR TARGET fmt))
+		find_package(fmt REQUIRED)
+		message(FATAL_ERROR "fmt not found, compiler too old, you're out of luck")
+	endif()
+endif()
+
+find_package(Threads)
 find_package(ZLIB QUIET)
-find_package(Threads)
 
 if(NOT ZLIB_FOUND)
-	message(FATAL_ERROR "The zlib development files were not found you this system, please install them and try again (hint: on debian/ubuntu use apt-get install zlib1g-dev)")
+	message(FATAL_ERROR "cifpp: The zlib development files were not found you this system, please install them and try again (hint: on debian/ubuntu use apt-get install zlib1g-dev)")
+endif()
+
+include(FindPkgConfig)
+
+if(PKG_CONFIG_FOUND)
+	pkg_check_modules(PCRE2 IMPORTED_TARGET libpcre2-8)
+
+	if(PCRE2_FOUND)
+		message(STATUS "Using pcre2 found using pkg-config")
+	endif()
+endif()
+
+if(NOT PCRE2_FOUND)
+	add_subdirectory(pcre2-simple)
 endif()
 
 # Using Eigen3 is a bit of a thing. We don't want to build it completely since
@@ -236,19 +208,16 @@
 	get_target_property(EIGEN_INCLUDE_DIR Eigen3::Eigen
 		INTERFACE_INCLUDE_DIRECTORIES)
 else()
-	# Create a private copy of eigen3 and populate it only, no need to build
-	FetchContent_Declare(
-		my-eigen3
-		GIT_REPOSITORY https://gitlab.com/libeigen/eigen.git
-		GIT_TAG 3.4.0)
-
-	FetchContent_GetProperties(my-eigen3)
-
-	if(NOT my-eigen3_POPULATED)
-		FetchContent_Populate(my-eigen3)
-	endif()
-
-	set(EIGEN_INCLUDE_DIR ${my-eigen3_SOURCE_DIR})
+	# Use ExternalProject since FetchContent always tries to install the result...
+	ExternalProject_Add(my-eigen3
+		URL https://gitlab.com/libeigen/eigen/-/archive/3.4.0/eigen-3.4.0.zip
+		DOWNLOAD_EXTRACT_TIMESTAMP TRUE
+		CONFIGURE_COMMAND ""
+		BUILD_COMMAND ""
+		INSTALL_COMMAND "")
+
+	ExternalProject_Get_Property(my-eigen3 SOURCE_DIR)
+	set(EIGEN_INCLUDE_DIR ${SOURCE_DIR})
 endif()
 
 # Create a revision file, containing the current git version info
@@ -337,6 +306,10 @@
 add_library(cifpp)
 add_library(cifpp::cifpp ALIAS cifpp)
 
+if(TARGET my-eigen3)
+	add_dependencies(cifpp my-eigen3)
+endif()
+
 target_sources(cifpp
 	PRIVATE ${project_sources}
 	${CMAKE_CURRENT_SOURCE_DIR}/src/symop_table_data.hpp
@@ -349,18 +322,8 @@
 # The code now really requires C++20
 target_compile_features(cifpp PUBLIC cxx_std_20)
 
-set(CMAKE_DEBUG_POSTFIX d)
-set_target_properties(cifpp PROPERTIES DEBUG_POSTFIX "d")
-
 generate_export_header(cifpp EXPORT_FILE_NAME
 	${CMAKE_CURRENT_SOURCE_DIR}/include/cif++/exports.hpp)
-
-if(BOOST_REGEX)
-	target_compile_definitions(cifpp PRIVATE USE_BOOST_REGEX=1
-		BOOST_REGEX_STANDALONE=1)
-	get_target_property(BOOST_REGEX_INCLUDE_DIR Boost::regex
-		INTERFACE_INCLUDE_DIRECTORIES)
-endif()
 
 if(MSVC)
 	target_compile_definitions(cifpp PUBLIC NOMINMAX=1)
@@ -372,11 +335,38 @@
 	cifpp
 	PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
 	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
-	PRIVATE "${BOOST_REGEX_INCLUDE_DIR}" "${EIGEN_INCLUDE_DIR}")
-
-target_link_libraries(cifpp PUBLIC Threads::Threads ZLIB::ZLIB $<$<TARGET_EXISTS:std::atomic>:std::atomic>)
+	PRIVATE "${EIGEN_INCLUDE_DIR}")
+
+target_link_libraries(cifpp
+	PUBLIC Threads::Threads ZLIB::ZLIB $<$<TARGET_EXISTS:std::atomic>:std::atomic>)
+
+if(PCRE2_FOUND)
+	target_include_directories(cifpp PRIVATE ${PCRE2_INCLUDE_DIRS})
+	target_link_libraries(cifpp PRIVATE ${PCRE2_LINK_LIBRARIES})
+else()
+	target_link_libraries(cifpp PRIVATE $<BUILD_INTERFACE:pcre2s>)
+endif()
+
+if(fmt_FOUND)
+	target_link_libraries(cifpp PUBLIC fmt)
+endif()
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 	target_link_options(cifpp PRIVATE -undefined dynamic_lookup)
 endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 
+if(CIFPP_DOWNLOAD_CCD)
+	# download the components.cif file from CCD
+	set(COMPONENTS_CIF ${CMAKE_CURRENT_SOURCE_DIR}/rsrc/components.cif)
+
+	if(EXISTS ${COMPONENTS_CIF})
+		file(SIZE ${COMPONENTS_CIF} CCD_FILE_SIZE)
+
+		if(CCD_FILE_SIZE EQUAL 0)
+			message(STATUS "cifpp: Removing empty ${COMPONENTS_CIF} file")
+			file(REMOVE "${COMPONENTS_CIF}")
+		endif()
+	endif()
+
+	if(NOT EXISTS ${COMPONENTS_CIF})
+		# Since the file(DOWNLOAD) command in cmake does not use compression, we try

=== docs/CMakeLists.txt ===
find_package(Doxygen REQUIRED)
find_package(Sphinx REQUIRED)

# Find all the public headers
# get_target_property(CIFPP_PUBLIC_HEADER_DIR libCIFPP INTERFACE_INCLUDE_DIRECTORIES)
set(CIFPP_PUBLIC_HEADER_DIR ${PROJECT_SOURCE_DIR}/include)
file(GLOB_RECURSE CIFPP_PUBLIC_HEADERS ${CIFPP_PUBLIC_HEADER_DIR}/*.hpp)

set(DOXYGEN_INPUT_DIR ${CIFPP_PUBLIC_HEADER_DIR})
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/xml)
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/index.xml)
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

# Replace variables inside @@ with the current values
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

add_custom_command(
	OUTPUT ${DOXYGEN_OUTPUT_DIR}
	COMMAND ${CMAKE_COMMAND} -E make_directory ${DOXYGEN_OUTPUT_DIR})

add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
	BYPRODUCTS ${DOXYGEN_OUTPUT_DIR}
	DEPENDS ${DOXYGEN_OUTPUT_DIR} ${CIFPP_PUBLIC_HEADERS} ${DOXYFILE_OUT}
	COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
	MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
	COMMENT "Generating docs")

add_custom_target("Doxygen-${PROJECT_NAME}" ALL DEPENDS ${DOXYGEN_INDEX_FILE})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_SOURCE_DIR}/conf.py @ONLY)

set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)

add_custom_target("Sphinx-${PROJECT_NAME}" ALL
	COMMAND ${SPHINX_EXECUTABLE} -b html
	-Dbreathe_projects.${PROJECT_NAME}=${DOXYGEN_OUTPUT_DIR}
	${SPHINX_SOURCE} ${SPHINX_BUILD}
	DEPENDS ${DOXYGEN_INDEX_FILE}
	BYPRODUCTS ${CMAKE_CURRENT_SOURCE_DIR}/api
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating documentation with Sphinx")

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sphinx/
	DESTINATION ${CMAKE_INSTALL_DOCDIR}
	PATTERN .doctrees EXCLUDE
	PATTERN .buildinfo EXCLUDE)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(cifpp_example LANGUAGES CXX)

find_package(cifpp REQUIRED)

add_executable(example example.cpp)
target_link_libraries(example cifpp::cifpp)

=== pcre2-simple/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# 
# Copyright (c) 2025 Maarten L. Hekkelman
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# A simplified wrapper CMakeLists.txt file for PCRE2
#
# This will generate an OBJECT library so it can be linked into another library

cmake_minimum_required(VERSION 3.25)

include(FetchContent)

project(pcre2s VERSION 1.0.0 LANGUAGES C CXX)

# The original code:

file(DOWNLOAD https://github.com/PCRE2Project/pcre2/releases/download/pcre2-10.46/pcre2-10.46.tar.gz
    ${CMAKE_CURRENT_BINARY_DIR}/pcre2-code.tgz
    EXPECTED_HASH SHA256=8d28d7f2c3b970c3a4bf3776bcbb5adfc923183ce74bc8df1ebaad8c1985bd07)
file(ARCHIVE_EXTRACT INPUT ${CMAKE_CURRENT_BINARY_DIR}/pcre2-code.tgz
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
set(PCRE2_SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/pcre2-10.46)
set(PCRE2_MAJOR 10)
set(PCRE2_MINOR 46)
set(PCRE2_VERSION "${PCRE2_MAJOR}.${PCRE2_MINOR}")
set(PCRE2_DATE "2024-06-09")

# Some needed configuration options

# option(PCRE2_BUILD_PCRE2_8 "Build 8 bit PCRE2 library" ON)
# option(PCRE2_BUILD_PCRE2_16 "Build 16 bit PCRE2 library" OFF)
# option(PCRE2_BUILD_PCRE2_32 "Build 32 bit PCRE2 library" OFF)

option(PCRE2_STATIC_PIC "Build the static library with the option position independent code enabled." OFF)

set(PCRE2_NEWLINE "LF" CACHE STRING "What to recognize as a newline (one of CR, LF, CRLF, ANY, ANYCRLF, NUL)." FORCE)
set_property(CACHE PCRE2_NEWLINE PROPERTY STRINGS "CR" "LF" "CRLF" "ANY" "ANYCRLF" "NUL")

set(PCRE2_LINK_SIZE "2" CACHE STRING "Internal link size (2, 3 or 4 allowed). See LINK_SIZE in config.h.in for details.")
set_property(CACHE PCRE2_LINK_SIZE PROPERTY STRINGS "2" "3" "4")

set(PCRE2_PARENS_NEST_LIMIT "250" CACHE STRING "Default nested parentheses limit. See PARENS_NEST_LIMIT in config.h.in for details.")
set(PCRE2_HEAP_LIMIT "20000000" CACHE STRING "Default limit on heap memory (kibibytes). See HEAP_LIMIT in config.h.in for details.")
set(PCRE2_MAX_VARLOOKBEHIND "255" CACHE STRING "Default limit on variable lookbehinds.")
set(PCRE2_MATCH_LIMIT "10000000" CACHE STRING "Default limit on internal looping. See MATCH_LIMIT in config.h.in for details.")
set(PCRE2_MATCH_LIMIT_DEPTH "MATCH_LIMIT" CACHE STRING "Default limit on internal depth of search. See MATCH_LIMIT_DEPTH in config.h.in for details.")
set(PCRE2GREP_BUFSIZE "20480" CACHE STRING "Buffer starting size parameter for pcre2grep. See PCRE2GREP_BUFSIZE in config.h.in for details.")
set(PCRE2GREP_MAX_BUFSIZE "1048576" CACHE STRING "Buffer maximum size parameter for pcre2grep. See PCRE2GREP_MAX_BUFSIZE in config.h.in for details.")
set(PCRE2_SUPPORT_JIT OFF CACHE BOOL "Enable support for Just-in-time compiling.")

if(${CMAKE_SYSTEM_NAME} MATCHES Linux|NetBSD)
    set(PCRE2_SUPPORT_JIT_SEALLOC OFF CACHE BOOL "Enable SELinux compatible execmem allocator in JIT (experimental).")
else()
    set(PCRE2_SUPPORT_JIT_SEALLOC IGNORE)
endif()

set(PCRE2GREP_SUPPORT_JIT ON CACHE BOOL "Enable use of Just-in-time compiling in pcre2grep.")
set(PCRE2GREP_SUPPORT_CALLOUT ON CACHE BOOL "Enable callout string support in pcre2grep.")
set(PCRE2GREP_SUPPORT_CALLOUT_FORK ON CACHE BOOL "Enable callout string fork support in pcre2grep.")
set(PCRE2_SUPPORT_UNICODE ON CACHE BOOL "Enable support for Unicode and UTF-8/UTF-16/UTF-32 encoding.")
set(PCRE2_SUPPORT_BSR_ANYCRLF OFF CACHE BOOL "ON=Backslash-R matches only LF CR and CRLF, OFF=Backslash-R matches all Unicode Linebreaks")
set(PCRE2_NEVER_BACKSLASH_C OFF CACHE BOOL "If ON, backslash-C (upper case C) is locked out.")
set(PCRE2_SUPPORT_VALGRIND OFF CACHE BOOL "Enable Valgrind support.")

if(MINGW)
    option(NON_STANDARD_LIB_PREFIX "ON=Shared libraries built in mingw will be named pcre2.dll, etc., instead of libpcre2.dll, etc." OFF)
    option(NON_STANDARD_LIB_SUFFIX "ON=Shared libraries built in mingw will be named libpcre2-0.dll, etc., instead of libpcre2.dll, etc." OFF)
endif()

# 

set(NEWLINE_DEFAULT "")

if(PCRE2_NEWLINE STREQUAL "CR")
    set(NEWLINE_DEFAULT "1")
elseif(PCRE2_NEWLINE STREQUAL "LF")
    set(NEWLINE_DEFAULT "2")
elseif(PCRE2_NEWLINE STREQUAL "CRLF")
    set(NEWLINE_DEFAULT "3")
elseif(PCRE2_NEWLINE STREQUAL "ANY")
    set(NEWLINE_DEFAULT "4")
elseif(PCRE2_NEWLINE STREQUAL "ANYCRLF")
    set(NEWLINE_DEFAULT "5")
elseif(PCRE2_NEWLINE STREQUAL "NUL")
    set(NEWLINE_DEFAULT "6")
else()
    message(FATAL_ERROR "The PCRE2_NEWLINE variable must be set to one of the following values: \"LF\", \"CR\", \"CRLF\", \"ANY\", \"ANYCRLF\".")
endif()

# Some tests

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckIncludeFile)

check_include_file(assert.h HAVE_ASSERT_H)
check_include_file(dirent.h HAVE_DIRENT_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(windows.h HAVE_WINDOWS_H)

check_symbol_exists(bcopy "strings.h" HAVE_BCOPY)
check_symbol_exists(memfd_create "sys/mman.h" HAVE_MEMFD_CREATE)
check_symbol_exists(memmove "string.h" HAVE_MEMMOVE)
check_symbol_exists(secure_getenv "stdlib.h" HAVE_SECURE_GETENV)
check_symbol_exists(strerror "string.h" HAVE_STRERROR)

check_c_source_compiles(
  "int main(void) { char buf[128] __attribute__((uninitialized)); (void)buf; return 0; }"
  HAVE_ATTRIBUTE_UNINITIALIZED
)

check_c_source_compiles(
  [=[
  extern __attribute__ ((visibility ("default"))) int f(void);
  int main(void) { return f(); }
  int f(void) { return 42; }
  ]=]
  HAVE_VISIBILITY
)

if(HAVE_VISIBILITY)
  set(PCRE2_EXPORT [=[__attribute__ ((visibility ("default")))]=])
else()
  set(PCRE2_EXPORT)
endif()

check_c_source_compiles("int main(void) { __assume(1); return 0; }" HAVE_BUILTIN_ASSUME)

check_c_source_compiles(
  [=[
  #include <stddef.h>
  int main(void) { int a,b; size_t m; __builtin_mul_overflow(a,b,&m); return 0; }
  ]=]
  HAVE_BUILTIN_MUL_OVERFLOW
)

check_c_source_compiles(
  "int main(int c, char *v[]) { if (c) __builtin_unreachable(); return (int)(*v[0]); }"
  HAVE_BUILTIN_UNREACHABLE
)

# # Check whether Intel CET is enabled, and if so, adjust compiler flags. This
# # code was written by PH, trying to imitate the logic from the autotools
# # configuration.

# check_c_source_compiles(
#   [=[
#   #ifndef __CET__
#   #error CET is not enabled
#   #endif
#   int main() { return 0; }
#   ]=]
#   INTEL_CET_ENABLED
# )

# if(INTEL_CET_ENABLED)
#   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mshstk")
# endif()

# Set up some dependencies first

configure_file(
    ${PCRE2_SOURCE_DIR}/src/pcre2_chartables.c.dist
    ${CMAKE_CURRENT_BINARY_DIR}/pcre2_chartables.c
    COPYONLY
)

configure_file(
    ${PCRE2_SOURCE_DIR}/config-cmake.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/interface/config.h
    @ONLY
)

configure_file(
    ${PCRE2_SOURCE_DIR}/src/pcre2.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/interface/pcre2.h
    @ONLY
)

# Define our library

list(APPEND PCRE2_HEADERS
    ${CMAKE_CURRENT_BINARY_DIR}/interface/pcre2.h)

list(APPEND PCRE2_SOURCES
    ${PCRE2_SOURCE_DIR}/src/pcre2_auto_possess.c
    ${CMAKE_CURRENT_BINARY_DIR}/pcre2_chartables.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_chkdint.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_compile.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_compile_class.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_config.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_context.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_convert.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_dfa_match.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_error.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_extuni.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_find_bracket.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_jit_compile.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_maketables.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_match.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_match_data.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_newline.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_ord2utf.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_pattern_info.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_script_run.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_serialize.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_string_utils.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_study.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_substitute.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_substring.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_tables.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_ucd.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_valid_utf.c
    ${PCRE2_SOURCE_DIR}/src/pcre2_xclass.c
)

add_library(pcre2s OBJECT)

target_sources(pcre2s
    PRIVATE ${PCRE2_SOURCES}
    PUBLIC
    FILE_SET pcre2_headers TYPE HEADERS
    BASE_DIRS ${PCRE2_SOURCE_DIR}/include ${CMAKE_CURRENT_BINARY_DIR}/interface
    FILES ${PCRE2_HEADERS}
)

target_compile_definitions(pcre2s PUBLIC PCRE2_CODE_UNIT_WIDTH=8 HAVE_CONFIG_H)
if(NOT BUILD_SHARED_LIBS)
    target_compile_definitions(pcre2s PUBLIC PCRE2_STATIC)
endif()

target_include_directories(pcre2s PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/interface ${PCRE2_SOURCE_DIR}/src)

if(PCRE2_STATIC_PIC)
    set_target_properties(pcre2s PROPERTIES POSITION_INDEPENDENT_CODE 1)
endif()

# # Installation and config files

# include(CMakePackageConfigHelpers)
# include(GenerateExportHeader)

# # Install rules
# install(TARGETS pcre2s
#     EXPORT pcre2s
#     FILE_SET pcre2_headers DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# if(MSVC AND BUILD_SHARED_LIBS)
#     install(
#         FILES $<TARGET_PDB_FILE:pcre2s>
#         DESTINATION ${CMAKE_INSTALL_LIBDIR}
#         OPTIONAL)
# endif()

# install(EXPORT pcre2s
#     NAMESPACE pcre2s::
#     FILE "pcre2s-targets.cmake"
#     DESTINATION lib/cmake/pcre2s)

# configure_package_config_file(
#     ${CMAKE_CURRENT_SOURCE_DIR}/pcre2s-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/pcre2s/pcre2s-config.cmake
#     INSTALL_DESTINATION lib/cmake/pcre2s)

# install(
#     FILES "${CMAKE_CURRENT_BINARY_DIR}/pcre2s/pcre2s-config.cmake"
#     "${CMAKE_CURRENT_BINARY_DIR}/pcre2s/pcre2s-config-version.cmake"
#     DESTINATION lib/cmake/pcre2s)

# set_target_properties(
#     pcre2s
#     PROPERTIES VERSION ${PCRE2_VERSION}
#     SOVERSION ${PCRE2_VERSION}
#     INTERFACE_pcre2s_MAJOR_VERSION ${PCRE2_MAJOR})

# set_property(
#     TARGET pcre2s
#     APPEND
#     PROPERTY COMPATIBLE_INTERFACE_STRING pcre2s_MAJOR_VERSION)

# write_basic_package_version_file(
#     "${CMAKE_CURRENT_BINARY_DIR}/pcre2s/pcre2s-config-version.cmake"
#     VERSION "${PCRE2_VERSION}"
#     COMPATIBILITY AnyNewerVersion)

# # Testing

# if(PROJECT_IS_TOP_LEVEL)
#     include(CTest)

#     if(BUILD_TESTING)
#         add_subdirectory(test)
#     endif()
# endif()

=== debian/changelog ===
libcifpp (9.0.1-1) experimental; urgency=medium

  * Fix SONAME/package name mismatch

  [ Carles Pina i Estany ]
  * Added po-debconf Catalan translation

  [ Maarten L. Hekkelman ]
  * New upstream version 9.0.1

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 09 Sep 2025 11:09:20 +0200

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,7 @@
  Andreas Tille <tille@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- libboost-dev,
- libboost-regex-dev,
+ libpcre2-dev,
  libeigen3-dev,
  zlib1g-dev,
  po-debconf,
@@ -18,7 +17,7 @@
  python3-exhale,
  python3-sphinx-rtd-theme,
  python3-myst-parser
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
 Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
 Homepage: https://github.com/PDB-REDO/libcifpp
@@ -28,7 +27,7 @@
 Section: libdevel
 Architecture: any
 Depends:
- libcifpp7 (= ${binary:Version}),
+ libcifpp9 (= ${binary:Version}),
  libboost-regex-dev,
  zlib1g-dev,
  ${misc:Depends},
@@ -55,7 +54,7 @@
  This specific package contains the documentation you can use to develop new
  software using libcifpp.
 
-Package: libcifpp7
+Package: libcifpp9
 Architecture: any
 Depends:
  ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,optimize=-lto

# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DENABLE_TESTING=ON -DCIFPP_DOWNLOAD_CCD=OFF -DBUILD_DOCUMENTATION=ON

override_dh_auto_build:
	export http_proxy=127.0.0.1:9
	export https_proxy=127.0.0.1:9
	dh_auto_build

=== debian/tests/control ===
Tests: run-build-test
Depends:
 build-essential,
 libcifpp-dev,
 zlib1g-dev,
 cmake
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libcifpp-$1\.tar\.gz/ \
  https://github.com/PDB-REDO/libcifpp/tags .*/v?(\d\S+)\.tar\.gz

## libcifpp 9.0.5

=== debian/changelog ===
libcifpp (9.0.5-2) unstable; urgency=medium

  * Added debian/clean, Closes: #1048817

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 23 Nov 2025 13:32:02 +0100

libcifpp (9.0.5-1) unstable; urgency=medium

  * New upstream version 9.0.5

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 09:25:54 +0100

libcifpp (9.0.1-2) unstable; urgency=medium

  * Transition, Closes: #1120992

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 19 Nov 2025 11:25:34 +0100
